# this Make file is very basic.  It has been written for MASM v6.0
# (ML.EXE actually) and NMAKE.EXE.  The LINK.EXE used here is from C v7.0,
# and RC.EXE & LIBW.LIB came from the SDK v3.1.
# Note that LIBW provides access to the Windows functions.

#This Make file is for assembly programs that do NOT have the startup code
#"built in", so require linking of the startup code.
#Microsoft provides the startup code as APPENTRY.OBJ (with MASM6.1),
#and Borland provides C0WS.OBJ for small model programs (that's a zero,
#not a letter, in C0WS).

#The /Zi and /CO switches turn on debugging information for CODEVIEW.
#Note that if you have any trouble with LINK unable to find library
#files, make sure the environment variables are set correctly, as per
#Microsoft's documentation. I have given some guidelines on this in my
#previous book. Alternatively, put everything into the current
#directory.

#If for some reason you are using the Borland library:
# Note that Borland C++ v2.5 names the Windows library CWINS.LIB, while
# v3.0 names it CWS.LIB.  The BorlandC runtime
# library is CS.LIB, which could be placed immediately after CWS, if you
# need it.  Note that the "S" postfix designates the small model.

#Note that ML.EXE is the new name for MASM, and the /c switch
#disables automatic linking, /VM turns on usage of virtual memory
#while assembling, for large programs... but don't run ML from
#within Windows... exit Windows first (note that ML version 6.1
#doesn't recognise the /VM switch).

#To run this Make file...
#  NMAKE MASM60b.MAK


fn = ASMDEMO2
all:$(fn).EXE

$(fn).OBJ : $(fn).ASM
	ML /c /Zi  $(fn).ASM

$(fn).RES : $(fn).RC
	RC -r $(fn).RC

$(fn).EXE : $(fn).OBJ $(fn).DEF $(fn).RES
	LINK /CO /NOD  APPENTRY $(fn), $(fn),$(fn),  libw, $(fn).DEF
	RC /30 $(fn).RES

#Note that if you use the tools from the SDK3.1, such as RC.EXE, and you
#want your program to work with both Windows 3.0 and 3.1, put "/30" in 
#second execution of RC, as shown.  Also your source program should have
#"WINVER = 0x0300" before the WINDOWS.INC is included, if using a 
#WINDOWS.INC derived from WINDOWS.H supplied with SDK 3.1.  
#(my WINDOWS.INC on the Companion Disk is derived from SDK 3.0, which
#avoids certain problems).
