# WINAPP.MAK
# Used to assemble and link WINAPP.ASM.
# RC.EXE & LIBW.LIB came from the SDK v3.1.
# Note that LIBW provides access to the Windows functions.
# The /Zi and /CO switches turn on debugging information for CODEVIEW.
# Note that if you have any trouble with LINK unable to find library
# files, make sure the environment variables are set correctly.
# Note that ML.EXE is the new name for MASM (from v6.0), and the /c switch
# disables automatic linking.
# To run this Make file...
#  NMAKE WINAPP.MAK
#/Zm switch is used on the 32-bit segment, for compatibility with masm5.1.


fn = WINAPP
fn2 = HEAVEN
all:$(fn).EXE

$(fn).OBJ : $(fn).ASM
	ML /c /Zi  $(fn).ASM

        ML /c /Zi /Zm  $(fn2).ASM

$(fn).RES : $(fn).RC
	RC -r $(fn).RC

$(fn).EXE : $(fn).OBJ $(fn).DEF $(fn).RES
	LINK /CO /NOD	$(fn) $(fn2), $(fn),$(fn),  libw, $(fn).DEF
	RC /30 $(fn).RES

#Note that if you use the tools from the SDK3.1, such as RC.EXE, and you
#want your program to work with both Windows 3.0 and 3.1, put "/30" in 
#second execution of RC, as shown.  Also your source program should have
#"WINVER = 0x0300" before the WINDOWS.INC is included, if using a 
#WINDOWS.INC derived from WINDOWS.H supplied with SDK 3.1.  
#(my WINasm60.INC on the Companion Disk is derived from SDK 3.0, which
#avoids certain problems).
