;
; Copyright Shadow '1999
;

.586p
.model flat,stdcall
locals
jumps

extrn   GetFileTime     :proc
extrn   lstrcpyA        :proc
extrn   GetStdHandle    :proc
extrn   SetFileTime     :proc
UNICODE = 0

include w32.inc

.data
buffer          db 128 dup(0)
message         db "ZAP! accesstime->filetime utility by Shadow",10,13,\
                   "===========================================",10,13,0
filename        db "Filename to zap:",10,13,0
success         db "Filetime updated successfully.",0
error           db "File not found or time not updated.",0
hstdout         dd 0
hstdin          dd 0
hfile           dd 0
ft1             FILETIME <?>
ft2             FILETIME <?>
ft3             FILETIME <?>
bytes           dd 0
pbytes          dd 0
.code

start:
;
; Open stdin,stdout to console
;
        call    GetStdHandle,STD_OUTPUT_HANDLE
        mov     hstdout,eax

        call    GetStdHandle,STD_INPUT_HANDLE
        mov     hstdin,eax

;
; Write text to console
;
        call    lstrlen,offset message
        call    WriteFile,hstdout,offset message,eax,offset pbytes,0

;
; Read commandline
;
        call    GetCommandLine
        mov     pbytes,eax

;
; If parameters found skip question
;
        call    Parse,eax
        or      eax,eax
        jnz     @@skip

;
; read filename from console
;
        call    lstrlen,offset filename
        mov     bytes,eax
        call    WriteFile,hstdout,offset filename,bytes,offset pbytes,0

        call    ReadFile,hstdin,offset buffer,100,offset pbytes,0
        cmp     pbytes,2
        je      @@exit

;
; strip terminating chars
;
        call    lstrlen,offset buffer
        mov     buffer[eax-2],0

@@skip:
;
; open file
;
        call    CreateFile,offset buffer,GENERIC_WRITE+GENERIC_READ,0,0,\
        OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
        cmp     eax,INVALID_HANDLE_VALUE
        je      @@exit
        mov     hfile,eax

;
; read filetimes and set times to accesstime
;
        call    GetFileTime,hfile,offset ft1,offset ft2,offset ft3
        call    SetFileTime,hfile,offset ft2,offset ft2,offset ft2
        or      eax,eax
        jz      @@exit
        call    CloseHandle,hfile

        call    lstrlen,offset success
        mov     bytes,eax
        call    WriteFile,hstdout,offset success,bytes,offset pbytes,0
        jmp     @@normal
@@exit:
        call    lstrlen,offset error
        call    WriteFile,hstdout,offset error,eax,offset pbytes,0
@@normal:
        call    ExitProcess,0

;
; this function parses commandline. 
;
; returns: eax = 0 - filename not found , 1 - filename found
Parse proc pstr:DWORD
        call    lstrlen,pstr
        mov     ecx,eax
        mov     edi,pstr
        mov     al,' '
        repne
        scasb
        jcxz    @@notfound
        call    lstrcpyA,offset buffer,edi
        mov     eax,1
        ret
@@notfound:
        xor     eax,eax
        ret
Parse endp


ends
end start
