;BackGround Randomizer 2.2a
;April 1, 1998

.486p
.model flat, STDCALL
%nolist
include win32.inc
include bg2a.inc
%list

;------------------------------------------------------------------------------------------------------------
BUF_SIZE        equ     20                                      ; fileBuffer size

;------------------------------------------------------------------------------------------------------------
.data
fileBuffer      db      BUF_SIZE dup (MAX_PATH dup (?))         ; char fileBuffer[20][128]
path            db      MAX_PATH dup (?)                        ; char path[MAXPATH]
bslash          db      '\',0                                   ; slash to append to path
fmask           db      '*.bmp',0                               ; file mask
regKey          db      'Control Panel\desktop',0               ; registry Key
regKey2         db      'Wallpaper',0                           ; registry Sub Key
skey            dd      0                                       ; registry key handle
RandNum         dd      0                                       ; random number seed
wFindData       WIN32_FIND_DATA <?>                             ; struct for FindFile


;------------------------------------------------------------------------------------------------------------
.CODE
start:
        push    offset path             ; directory buffer
        push    MAX_PATH                ; size of buffer
        call    GetCurrentDirectoryA    ; retrieve current directory

        push    offset bslash
        push    offset path
        call    strcat                  ; append \ to end of path


        call    GetTickCount            ; get seed for random
        push    eax
        call    srand                   ; seed random generator with time

        call    GetBackground           ; return ptr to bitmap filename in eax

        push    eax                     ; source (bitmap)
        push    offset path             ; destination (path)
        call    strcat                  ; strcat(path, GetBackground());

SetWallP:
        push    0                       ; bool tile (tile background - not implemented)
        push    offset path             ; char* BMPFile
        call    SetWallpaper            ; SetWallPaper(BMPFile, tile);

endprog:
        ret                             ; terminate

;--------------------------------------------------------------
; void SetWallpaper(char* BMPFile, bool tile);
; Sets the wallpaper using SystemParametersInfo API call
; BMPFile = full path to bitmap
; tile = tile bitmap or center it (not implemented)
; no return
SetWallpaper    proc  BMPFile:DWORD, tile:DWORD
        pusha                           ; save registers
        push    offset skey             ; phkResult
        push    KEY_ALL_ACCESS          ; samDesired
        push    0                       ; dwReserved
        push    offset regKey           ; lpszSubKey
        push    HKEY_CURRENT_USER       ; hKey
        call    RegOpenKeyExA           ; RegOpenKeyEx(HKEY_CURRENT_USER,"Control Panel\\desktop", 0, KEY_ALL_ACCESS, &skey);
        cmp     eax,ERROR_SUCCESS
        jne     sw_end                  ; exit if RegOpenKey fails

        push    BMPFile
        call    strlen                  ; get string length of BMPFile

        push    eax                     ; cbData
        push    BMPFile                 ; lpData
        push    REG_SZ                  ; dwType
        push    0                       ; reserved
        push    offset regKey2          ; lpValueName
        push    skey                    ; hKey
        call    RegSetValueExA          ; RegSetValueEx(skey, "Wallpaper", 0, REG_SZ, BMPfile, strlen(BMPfile));

        push    0                       ; fWinIni
        push    BMPFile                 ; pvParam
        push    0                       ; uiParam
        push    SPI_SETDESKWALLPAPER    ; uiAction
        call    SystemParametersInfoA   ; SystemParametersInfo( SPI_SETDESKWALLPAPER, 0, BMPfile, 0 );

sw_end:
        popa                            ; restora all registers
        ret                             ; return from call
SetWallpaper    endp


;--------------------------------------------------------------
; char* Getbackground(void);
; returns a string ptr to a randomly generated bitmap file
GetBackground   proc  uses ebx ecx
        local   hFindFile:DWORD         ; FindFile handle

        push    offset wFindData        ; lpFindFileData
        push    offset fmask            ; lpFileName
        call    FindFirstFileA          ; FindFirstFile(lpFileName, lpFindFileData);

        mov     hFindFile,eax           ; FindFile handle
        cmp     hFindFile,INVALID_HANDLE_VALUE
        je      bg_done                 ; quit if FindFile fails

        xor     ebx,ebx                 ; counter
bg_findloop:
        mov     eax, ebx                ; index = (row * MAX_PATH)
        mov     ecx,MAX_PATH
        mul     ecx

        push    offset wFindData.cFileName ; source (next found bitmap file)
        lea     ecx,fileBuffer[eax]
        push    ecx                     ; destination (filename buffer)
        call    strcpy                  ; move found file into buffer
        inc     ebx

        push    offset wFindData        ; lpFindFileDaa
        push    hFindFile               ; hFindFile
        call    FindNextFileA           ; FindNextFile( handle, wFindData);
        cmp     eax,0
        jne     bg_findloop             ; end loop if no more files found

bg_done:
        push    ebx                     ; ebx = files_found
        call    rand                    ; rand(files_found);
        mov     ecx,MAX_PATH
        mul     ecx                     ; get offset in multidimensional array

        lea     eax,fileBuffer[eax]     ; get random filename from buffer
        ret                             ; return ptr to string
GetBackground   endp


;--------------------------------------------------------------
; int strlen(char* str)
; return length of a null terminated string
; str = ptr to string
; no return
strlen  proc    uses esi eax, str:DWORD
        mov     esi,str         ; SI = string pointer
        xor     eax,eax         ; init counter to 0
s1_loop:
        lodsb                   ; load char
        test    al,al           ; loop while char not zero
        jz      sl_done
        inc     eax             ; increment length counter
        jmp     s1_loop
sl_done:
        ret                     ; return length
strlen  endp


;--------------------------------------------------------------
; void strcpy(char* dest, char*src);
; moves one tring to another
; dest = ptr to destionation
; src = ptr to null terminated sring
; no return
strcpy  proc    uses esi edi, dest:DWORD, src:DWORD
        mov     esi,src         ; put source address into esi
        mov     edi,dest        ; destination address to edi
scp_loop:
        lodsb                   ; load char from esi
        mov     [edi],al        ; store char to address in edi
        inc     edi
        test    al,al           ; loop while not zero
        jnz     scp_loop
scp_done:
        ret
strcpy  endp




;------------------------------------------------------------
; void strcat(char* str1, char* str2);
; append one string to the end of another
; str1 = ptr to string to append to
; str2 = ptr to string to append with
; no return
strcat  proc    uses esi edi eax, str1:DWORD, str2:DWORD
        mov     esi,str1        ;SI = destination
sc_cloop:
        lodsb                   ;Load char
        test    al,al           ;Loop while not zero
        jnz     sc_cloop

        mov     edi,esi         ;DI = destination
        dec     edi
        mov     esi,str2        ;SI = source
sc_loop:
        lodsb                   ;Load char
        mov     [edi],al        ;Store char
        inc     edi
        test    al,al           ;Loop while not zero
        jnz     sc_loop
sc_done:
        ret                     ;Return
strcat  endp


;------------------------------------------------
; int rand(int max);
; max = integer of maximum number of random value
; returns random number from 0 to (max-1)
rand    proc    uses ebx, max:DWORD
        imul    eax,RandNum,19660Dh
        add     eax,10DCDh      ;EAX = RandNum * 19660Dh + 10DCDh
        mov     RandNum,eax     ;Save random number
        mov     ebx,max         ;EBX = maximum
        div     ebx             ;Divide by maximum
        mov     eax,edx         ;remainder in edx

        ret
rand    endp


;-----------------------------------------------
; void srand(int seed);
; seeds random number generator
; no return
srand   proc    uses eax, seed:DWORD
        mov     eax,seed
        mov     RandNum,eax       ;Save it
        ret
srand   endp

;------------------------------------------------------------------------------------------------------------
        end start
        ends