; tdsetup.inc  (c) Minde  06/08/99 montana@is.lt
; Content:  TASM DirectSetup include file ver. 1.2
; converted from dsetup.h, DX ver. 6.1
;
;  Feel free to use or distribute the package, part or whole, for any
; non-commercial use preferably crediting me.
;  Also feel free to contact me at the above address if you experience any
; problems or notice any omissions.
`
; API
DirectXSetup                  = DirectXSetupA
DirectXDeviceDriverSetup      = DirectXDeviceDriverSetupA
DirectXRegisterApplication    = DirectXRegisterApplicationA

DirectXSetupA                   PROCDESC STDCALL :DWORD, :DWORD, :DWORD
DirectXDeviceDriverSetupA       PROCDESC STDCALL :DWORD, :DWORD, :DWORD, DWORD
DirectXRegisterApplicationA     PROCDESC STDCALL :DWORD, :DWORD
DirectXSetupGetVersion          PROCDESC STDCALL :DWORD, :DWORD
DirectXUnRegisterApplication    PROCDESC STDCALL :DWORD, :DWORD
DirectXSetupCallback            PROCDESC STDCALL :DWORD
DirectXSetupCallbackFunction    PROCDESC STDCALL :DWORD, :DWORD, :DWORD, :DWORD, :DWORD



DIRECTXREGISTERAPPA STRUCT
directxregisterappa_dwSize                  DD ?
directxregisterappa_dwFlags                 DD ?
directxregisterappa_lpszApplicationName     DD ?
directxregisterappa_lpGUID                  DD ?
directxregisterappa_lpszFilename            DD ?
directxregisterappa_lpszCommandLine         DD ?
directxregisterappa_lpszPath                DD ?
directxregisterappa_lpszCurrentDirectory    DD ?
DIRECTXREGISTERAPPA ENDS


DSETUP_CB_UPGRADEINFO struct ; NOT MODIFIED...
UpgradeFlags    DD ?
DSETUP_CB_UPGRADEINFO ends

DSETUP_CB_FILECOPYERROR struct
dwError         DD ?
DSETUP_CB_FILECOPYERROR ends



; DSETUP Error Codes, must remain compatible with previous setup.
DSETUPERR_SUCCESS_RESTART       = 1
DSETUPERR_SUCCESS               = 0
DSETUPERR_BADWINDOWSVERSION     = -1
DSETUPERR_SOURCEFILENOTFOUND    = -2
DSETUPERR_BADSOURCESIZE         = -3
DSETUPERR_BADSOURCETIME         = -4
DSETUPERR_NOCOPY                = -5
DSETUPERR_OUTOFDISKSPACE        = -6
DSETUPERR_CANTFINDINF           = -7
DSETUPERR_CANTFINDDIR           = -8
DSETUPERR_INTERNAL              = -9
;DSETUPERR_NTWITHNO3D           = -10  obsolete, see docs
DSETUPERR_UNKNOWNOS             = -11
DSETUPERR_USERHITCANCEL         = -12
DSETUPERR_NOTPREINSTALLEDONNT   = -13


; DSETUP flags. DirectX 5.0 apps should use these flags only.
DSETUP_DDRAWDRV     = 000000008h ; install DirectDraw Drivers
DSETUP_DSOUNDDRV    = 000000010h ; install DirectSound Drivers
DSETUP_DXCORE       = 000010000h ; install DirectX runtime
DSETUP_DIRECTX = DSETUP_DXCORE or DSETUP_DDRAWDRV or DSETUP_DSOUNDDRV;
DSETUP_TESTINSTALL  = 000020000 ; ust test install, don't do anything

; String Constants
MAX_INFLINE     = (16*1024)
MAX_DESCRIPTION     = 256


; These OBSOLETE flags are here for compatibility with pre-DX5 apps only.
; They are present to allow DX3 apps to be recompiled with DX5 and still work.
; DO NOT USE THEM for DX5. They will go away in future DX releases.

DSETUP_DDRAW            = 000000001h ; install DirectDraw
DSETUP_DSOUND           = 000000002h ; install DirectSound
DSETUP_DPLAY            = 000000004h ; install DirectPlay
DSETUP_DDRAWDRV         = 000000008h ; install DirectDraw Drivers
DSETUP_DSOUNDDRV        = 000000010h ; install DirectSound Drivers
DSETUP_DPLAYSP          = 000000020h ; install DirectPlay Providers
DSETUP_DVIDEO           = 000000040h ; install DirectVideo
DSETUP_D3D              = 000000200h ; install Direct3D
; This flag is obsolete.
; For NT, we now return either 0 for pre installed or
; DSETUPERR_NOTPREINSTALLEDONNT which implies this version of DirectX
; is not installed on this machine.
; DSETUP_REQUIRESD3D    = 000000400h + DSETUP_D3D ; install Direct3D, pop up dialog box on NT, if no D3D present
DSETUP_DINPUT       = 000000800h ; install DirectInput
DSETUP_DIRECTXSETUP = 000001000h ; install DirectXSetup DLL's
DSETUP_PROMPTFORDRIVERS = 010000000h ; prompt when replacing display/audio drivers
DSETUP_RESTOREDRIVERS   = 020000000h ; restore display/audio drivers
DSETUP_DIRECTX      = DSETUP_D3D+DSETUP_DDRAW+DSETUP_DSOUND+DSETUP_DPLAY+ \
        DSETUP_DINPUT+DSETUP_DDRAWDRV+DSETUP_DSOUNDDRV+DSETUP_DPLAYSP


;******************************************************************
; DirectX Setup Callback mechanism
;******************************************************************

; DSETUP Message Info Codes, passed to callback as Reason parameter.
  DSETUP_CB_MSG_NOMESSAGE                 = 0;
  DSETUP_CB_MSG_CANTINSTALL_UNKNOWNOS     = 1;
  DSETUP_CB_MSG_CANTINSTALL_NT            = 2;
  DSETUP_CB_MSG_CANTINSTALL_BETA          = 3;
  DSETUP_CB_MSG_CANTINSTALL_NOTWIN32      = 4;
  DSETUP_CB_MSG_CANTINSTALL_WRONGLANGUAGE = 5;
  DSETUP_CB_MSG_CANTINSTALL_WRONGPLATFORM = 6;
  DSETUP_CB_MSG_PREINSTALL_NT             = 7;
  DSETUP_CB_MSG_NOTPREINSTALLEDONNT       = 8;
  DSETUP_CB_MSG_SETUP_INIT_FAILED         = 9;
  DSETUP_CB_MSG_INTERNAL_ERROR            = 10;
  DSETUP_CB_MSG_CHECK_DRIVER_UPGRADE      = 11;
  DSETUP_CB_MSG_OUTOFDISKSPACE            = 12;
  DSETUP_CB_MSG_BEGIN_INSTALL             = 13;
  DSETUP_CB_MSG_BEGIN_INSTALL_RUNTIME     = 14;
  DSETUP_CB_MSG_BEGIN_INSTALL_DRIVERS     = 15;
  DSETUP_CB_MSG_BEGIN_RESTORE_DRIVERS     = 16;
  DSETUP_CB_MSG_FILECOPYERROR             = 17;


  DSETUP_CB_UPGRADE_TYPE_MASK      = 0000Fh;
  DSETUP_CB_UPGRADE_KEEP           = 00001h;
  DSETUP_CB_UPGRADE_SAFE           = 00002h;
  DSETUP_CB_UPGRADE_FORCE          = 00004h;
  DSETUP_CB_UPGRADE_UNKNOWN        = 00008h;
  DSETUP_CB_UPGRADE_HASWARNINGS    = 00100h;
  DSETUP_CB_UPGRADE_CANTBACKUP     = 00200h;
  DSETUP_CB_UPGRADE_DEVICE_ACTIVE  = 00800h;
  DSETUP_CB_UPGRADE_DEVICE_DISPLAY = 01000h;
  DSETUP_CB_UPGRADE_DEVICE_MEDIA   = 02000h;



;end of file
